using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Commander
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private Boolean RotateChart, MoveChart, ZoomChart, DChart, Go;
    private int StartX, StartY;

    private void Form1_Load(object sender, EventArgs e)
    {
			tChart1[0].FillSampleValues();

			//Steema.TeeChart.Styles.Pie pie2 = new Steema.TeeChart.Styles.Pie(tChart1.Chart);
			//pie2.FillSampleValues();

      button1.Text = "Reset";
      button2.Text = "Rotate";
      button3.Text = "Move";
      button4.Text = "Zoom";
      button5.Text = "3D%";
      button6.Text = "Editor";
    }

    private void button1_Click(object sender, EventArgs e)
    {
      SetDefaultAspect(tChart1);

      tChart1.Zoom.Allow = true;
      tChart1.Panning.Allow = Steema.TeeChart.ScrollModes.Both;

      RotateChart = false;
      MoveChart = false;
      ZoomChart = false;
      Go = false;
    }

    private void SetDefaultAspect(Steema.TeeChart.TChart c)
    {
      c.Aspect.Orthogonal = true;
      c.Aspect.HorizOffset = 0;
      c.Aspect.VertOffset = 0;
      c.Aspect.Zoom = 100;
      c.Aspect.Chart3DPercent = 15;
    }

    private void button2_Click(object sender, EventArgs e)
    {
      RotateChart = true;
      MoveChart = false;
      ZoomChart = false;
      DChart = false;

      DisableZoomScroll(tChart1);
    }

    private void button3_Click(object sender, EventArgs e)
    {
      RotateChart = false;
      MoveChart = true;
      ZoomChart = false;
      DChart = false;

      DisableZoomScroll(tChart1);
    }

    private void button4_Click(object sender, EventArgs e)
    {
      RotateChart = false;
      MoveChart = false;
      ZoomChart = true;
      DChart = false;

      DisableZoomScroll(tChart1);
    }

    private void button5_Click(object sender, EventArgs e)
    {
      //Changing Chart3DPercent
      RotateChart = false;
      MoveChart = false;
      ZoomChart = false;
      DChart = true;

      DisableZoomScroll(tChart1);

      //Standard functionality
      //tChart1.Aspect.View3D = !tChart1.Aspect.View3D;
    }

    private void button6_Click(object sender, EventArgs e)
    {
      tChart1.ShowEditor();
    }

    private void DisableZoomScroll(Steema.TeeChart.TChart c)
    {
      c.Zoom.Allow = false;
      c.Panning.Allow = Steema.TeeChart.ScrollModes.None;
    }

    private void tChart1_MouseDown(object sender, MouseEventArgs e)
    {
      if (RotateChart || MoveChart || ZoomChart || DChart)
      {
        Go = true;
        StartX = e.X;
        StartY = e.Y;        
      }
    }

    private void tChart1_MouseMove(object sender, MouseEventArgs e)
    {
      if (Go)
      {
        if (RotateChart) Rotate(tChart1, e);
        if (MoveChart) PanChart(tChart1, e);
        if (ZoomChart) Zoom(tChart1, e);
        if (DChart) Set3DPercent(tChart1, e);          
      }      
    }

    private void Set3DPercent(Steema.TeeChart.TChart c, MouseEventArgs e)
    {
			c.Aspect.Chart3DPercent += e.X - StartX;

			if (c.Aspect.Chart3DPercent < 0)
				c.Aspect.Chart3DPercent = 0;
			
			if (c.Aspect.Chart3DPercent > 100)
				c.Aspect.Chart3DPercent = 100;
    }

    private void Zoom(Steema.TeeChart.TChart c, MouseEventArgs e)
    {
			if (c.Aspect.Zoom +(e.X - StartX)>0)
				c.Aspect.Zoom += e.X - StartX;

			StartX = e.X;
			StartY = e.Y;
    }

    private void PanChart(Steema.TeeChart.TChart c, MouseEventArgs e)
    {
			c.Aspect.HorizOffset += e.X - StartX;
			c.Aspect.VertOffset += e.Y - StartY;

			StartX = e.X;
			StartY = e.Y;
    }

		private void Set3D()
		{
			tChart1.Aspect.View3D = true;
			//if (bView3D != null) bView3D.Pushed = true;
		}

		private int CorrectAngle(int aAngle)
		{
			int tmpResult = aAngle;
			if (tmpResult > 360) tmpResult = tmpResult - 360;
			else if (tmpResult < 0) tmpResult = 360 + tmpResult;

			return tmpResult;
		}

		private int CalcAngleChange(int aAngle, int aChange)
		{
			int tmpMinAngle;

			if (aChange > 0) return Math.Min(360, aAngle + aChange);
			else
			{
				if (tChart1.Graphics3D.SupportsFullRotation) tmpMinAngle = 0;
				else tmpMinAngle = 270;
				return Math.Max(tmpMinAngle, aAngle + aChange);
			}
		}

		static internal Steema.TeeChart.Styles.Pie FirstSeriesPie(Steema.TeeChart.Chart c)
		{
			foreach (Steema.TeeChart.Styles.Series s in c.Series)
				if ((s.GetType() == typeof(Steema.TeeChart.Styles.Pie)) && (s.Active))
					return (Steema.TeeChart.Styles.Pie)s;
			return null;
		}

		private void DoRotate(int X, int Y)
		{
			Set3D();
			tChart1.Aspect.Orthogonal = false;
			int tmpX = Steema.TeeChart.Utils.Round(90.0 * (X - StartX) / tChart1.Width);
			int tmpY = Steema.TeeChart.Utils.Round(90.0 * (StartY - Y) / tChart1.Height);

			Steema.TeeChart.Styles.Pie tmpSeries = FirstSeriesPie(tChart1.Chart);

			if (tChart1.Graphics3D.SupportsFullRotation)
			{
				tChart1.Aspect.Rotation = CorrectAngle(tChart1.Aspect.Rotation + tmpX);
				tChart1.Aspect.Elevation = CorrectAngle(tChart1.Aspect.Elevation + tmpY);
			}
			else
			{
				if (tmpSeries != null)
				{
					tChart1.Aspect.Rotation = 360;
					if (!tChart1.Graphics3D.SupportsFullRotation) tChart1.Aspect.Perspective = 0;
					if (tmpX != 0)
						tmpSeries.RotationAngle = CorrectAngle(tmpSeries.RotationAngle + tmpX);
				}
				else tChart1.Aspect.Rotation = CalcAngleChange(tChart1.Aspect.Rotation, tmpX);
				tChart1.Aspect.Elevation = CalcAngleChange(tChart1.Aspect.Elevation, tmpY);
			}
			StartX = X;
			StartY = Y;
		}

    private void Rotate(Steema.TeeChart.TChart c, MouseEventArgs e)
    {
			DoRotate(e.X, e.Y);
			//c.Aspect.Orthogonal = false;
			//Boolean ChartHasPies = false;

			//for (int i = 0; i < c.Series.Count; i++)
			//{
			//  if (tChart1[i] is Steema.TeeChart.Styles.Pie)
			//  {
			//    ChartHasPies = true;
			//    ((Steema.TeeChart.Styles.Pie)tChart1[i]).OtherSlice.Style = Steema.TeeChart.Styles.PieOtherStyles.None;
			//    break;
			//  }
			//}

			//int tmpElevation = c.Aspect.Elevation + (StartY - e.Y);
			//int tmpRotation = c.Aspect.Rotation + (e.X - StartX);

			//if (!ChartHasPies)
			//{
			//  c.Aspect.Elevation = tmpElevation;
			//  c.Aspect.Rotation = tmpRotation;
			//}
			//else
			//{
			//  c.Aspect.Elevation = tmpElevation > 270 ? tmpElevation : 270;
			//  c.Aspect.Rotation = tmpRotation > 270 ? tmpRotation : 270;
			//}

			//StartX = e.X;
			//StartY = e.Y;
    }

    private void tChart1_MouseUp(object sender, MouseEventArgs e)
    {
      if (RotateChart) Rotate(tChart1, e);
      if (MoveChart) PanChart(tChart1, e);
      if (ZoomChart) Zoom(tChart1, e);
      if (DChart) Set3DPercent(tChart1, e);       

      Go = false;
    }
  }
}